#include <stdlib.h>

#include "XMLError.h"

const char * const XMLErrorMessages[] =
{
	/* Application errors */
	"OK (no error)",
	"Out of memory (failed to allocate)",
	"LexBuffer failed to initialise",

	/* Parse errors */
	"Malformed entity",
	"Undefined entity id",
	"Expected Identifier was malformed",
	"'=' was expected at this point",
	"Expected attribute value was malformed",
	"Expected integer was malformed",
	"Number out of range",
	"Presumed comment tag was malformed",
	"The sequence \"--\" is not allowed in the middle of a comment",
	"Unexpected spurious characters",
	"Malformed PI tag",
	"(Assuming) Malformed CDATA section",
	"(Assuming) malformed DOCTYPE"
};

char const * XML_GetErrStr( XMLError err )
{
	if ( err > 0 && err < sizeof XMLErrorMessages / sizeof (char *) )
		return XMLErrorMessages[err];
	else
		return NULL;
}