#ifndef DSTR_H
#define DSTR_H

#include <stdlib.h>
#include "xmltypes.h"

typedef struct DStr {
	size_t		count;	/* How many characters in the string, measured in XMLChars */
	size_t		size;	/* Memory allocated, measured in XMLChars */
	XMLChar		s[1];	/* Use the "unwarranted chumminess with the C implementation," idiom. */
						/* Which is now valid in ANSI C99*/
} DStr;

extern	int			DStr_Create( DStr** );
extern	int			DStr_AppendChar( DStr**, XMLChar );
extern	int			DStr_AppendCStr( DStr**, XMLChar * );
extern	size_t		DStr_Length( DStr* );
extern	XMLChar	*	DStr_CStr( DStr * );
extern	int			DStr_Destroy( DStr** p );
extern	int			DStr_EnsureCapacity( DStr **ds, size_t capacity );
extern	int			DStr_EnsureRemaining( DStr **ds, size_t remaining );

#endif