#ifndef XML_H
#define XML_H


#include "LexBuffer.h"
#include "StateMachine.h"
#include "xmlerror.h"

#define INITIAL_MAX_TEXT_CHUNK	10000

typedef struct {
	size_t		MaxTextChunk;
} XMLOptions;

typedef struct XML {
	LexBuffer			*LexBuffer;
	StateMachine		StateMachine;
	XMLOptions			options;
	void				*UserData;
	TextNotify			*TextNotify;
	StartTagNotify		*StartTagNotify;
	EndTagNotify		*EndTagNotify;
	CommentNotify		*CommentNotify;
	PITagNotify			*PITagNotify;
	ParseErrorNotify	*ParseErrorNotify;
} XML;

extern	XMLError	XML_Create( XML** );
extern	XMLError	XML_SetTextHandler( XML*, TextNotify* );
extern	XMLError	XML_SetStartTagHandler( XML*, StartTagNotify* );
extern	XMLError	XML_SetEndTagHandler( XML*, EndTagNotify* );
extern	XMLError	XML_SetCommentHandler( XML*, CommentNotify* );
extern	XMLError	XML_SetPITagHandler( XML*, PITagNotify* );
extern	XMLError	XML_SetParseErrorHandler( XML*, ParseErrorNotify* );
extern	void		XML_SetUserData( XML*, void * );
extern	void*		XML_GetUserData( XML* );
extern	XMLError	XML_Destroy( XML** );
extern	XMLError	XML_SetMaxTextChunk( XML *, size_t );
extern	XMLError	XML_ParseBlock( XML *, XMLChar*, size_t );


#endif /* #ifndef _LEXAN_H_ */